/****************************************************************************

    PROGRAM: SSAVER.C     

    PURPOSE: A bare bones shell for a Win32 screen saver
 

****************************************************************************/
#pragma comment(lib, "ddraw.lib")
#pragma comment(lib, "dxguid.lib")
#pragma comment(lib, "winmm.lib")
#pragma comment(lib, "comctl32.lib")

#include <windows.h>            /* required for all Windows applications */
#include <stdlib.h>
#include <scrnsave.h>
#include "resource.h"
#include <ddraw.h>
#include "ddutil.h"
#include "fract.h"
#include <math.h>
#include "Movement.h"


HANDLE      hInst;                   /* current instance              */
UINT        wTimer            = 0;    // Timer id
bool        Initialized       = false;
CDisplay*   g_pDisplay        = NULL;
CMovement*  Move              = NULL;
bool        g_bActive         = false; 


HRESULT InitDirectDraw(HWND hWnd, int x, int y, int bpp)
{
    HRESULT             hr;

    g_pDisplay = new CDisplay();
    if( FAILED( hr = g_pDisplay->CreateFullScreenDisplay( hWnd, x, y, bpp ) ) )
    //if( FAILED( hr = g_pDisplay->CreateWindowedDisplay(hWnd, x, y) ) )
    {
        /*MessageBox( hWnd, TEXT("This display card does not support resolution. "),
                    TEXT("Game"), MB_ICONERROR | MB_OK );*/
        g_pDisplay = NULL;
        return hr;
    }

    return S_OK;
}

/*void Lock(LPDIRECTDRAWSURFACE7 s) 
{ 
  DDSURFACEDESC2 ddsd;
  if (s)
	{
		ddsd.dwSize = sizeof(ddsd); 
		s->Lock(0, &ddsd, DDLOCK_WAIT, 0);
		*videomemory = (unsigned int*)ddsd.lpSurface; 
		*pitch = ddsd.lPitch; 
	}
} 

void Unlock(LPDIRECTDRAWSURFACE7 s) 
{ 
	if (s) s->Unlock(0); 
} */


void DrawFrame(HWND hWnd)
{
  /*int pitch = 0;
  unsigned int * videomemory = NULL;*/
  if (g_pDisplay)
  {
    LPDIRECTDRAWSURFACE7 back = g_pDisplay->GetBackBuffer();

    Julia(Move->R*cos(Move->fi)-Move->X2/2,
          Move->R*sin(Move->fi)-Move->X2/2,
          Move->R*cos(Move->fi)+Move->X2/2,
          Move->R*sin(Move->fi)+Move->X2/2,
          63,
          Move->r*cos(Move->t),
          Move->r*sin(Move->t),
          back);

    HRESULT hr = g_pDisplay->Present();
    Move->move();
  }
  /*else MessageBox( hWnd, TEXT("ERROR"),
                    TEXT("Game"), MB_ICONERROR | MB_OK );*/
}

VOID FreeDirectDraw()
{
    SAFE_DELETE( g_pDisplay );
}

/*
 * RegisterDialogClasses -- Entry point for registering window classes 
 *                          required by configuration dialog box.
 */
BOOL WINAPI RegisterDialogClasses(HANDLE hInst)
{
    return true;
}


/*
 * ScreenSaverConfigureDialog -- Process the screen saver configuration
 *                               messages for the config dialog
 *
 */
BOOL CALLBACK ScreenSaverConfigureDialog(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
  /*if (!Initialized)
    {
      Initialized =true;
      HRESULT hr = InitDirectDraw(hWnd,640,480,32);
      DrawFrame(hWnd);
      g_pDisplay->Present();
      DrawFrame(hWnd);
      g_pDisplay->Present();
    }**/
    switch(Msg)
    {
        case WM_COMMAND:
			switch(LOWORD(wParam))
            {
                case IDOK:  // Exit the dialog
                case IDC_EXIT:
					EndDialog(hWnd, 42);
					break;
            }
        break;

        default:
		    return FALSE;
        break;
    }
    return TRUE;
}

				       
/****************************************************************************

    FUNCTION: ScreenSaverProc(HWND, UINT, WPARAM, LPARAM)

    PURPOSE:  Processes screen saver messages

****************************************************************************/

LONG CALLBACK ScreenSaverProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{ 
  if (!Initialized)
    {
      Initialized =true;
      HRESULT hr = InitDirectDraw(hWnd,320,240,32);
      //DrawFrame(hWnd);
      Move = new CMovement;
       srand(GetTickCount());
    }
  switch (msg) {
	case WM_TIMER:
        // Show a frame of our animation
		DrawFrame(hWnd);
		return 0;
	
    case WM_ERASEBKGND:        
		// Tell windows to send us timer messages at 5ms intervals
        wTimer = SetTimer(hWnd, 0, 20, NULL);  
		break;       

    case WM_DESTROY:            /* message: window being destroyed */
		  if (wTimer) // Stop our timer if it was created
			  KillTimer(hWnd, wTimer); 
      FreeDirectDraw();
      delete(Move);
     
		break;              
    }  
    
    return DefScreenSaverProc(hWnd, msg, wParam, lParam); 
}
