#include "fract.h"
#include "math.h"

void Julia(double x1,double y1, double x2, double y2,unsigned iter,double p,double q,LPDIRECTDRAWSURFACE7 s)
{

  if (!s) return;

  
  int nx,ny;       //position in bitmap
  double dx,dy;
  unsigned k;
  double xx2,xx1;
  double yy2,yy1;

  double r,max_r;
  double x1_orig=x1;
  double y1_orig=y1;


  DDSURFACEDESC2 ddsd;
  ddsd.dwSize = sizeof(ddsd); 
  HRESULT hr = s->Lock(0, &ddsd, DDLOCK_WAIT, 0);
  
  int width = ddsd.dwWidth;
  int height = ddsd.dwHeight;
	unsigned int * pixels = (unsigned int*)ddsd.lpSurface; 
	int pitch = ddsd.lPitch; 

  dx = (x2 - x1)/width;
  dy = (y2 - y1)/height;
  r=p*p+q*q;
  if (r>4) max_r=r;
  else   max_r=4;

  for(ny=0;ny<height;ny++)
  {
    x1=x1_orig;
    
    for(nx=0;nx<width;nx++)
    {
      k=0;
     
      xx1=x1;
      yy1=y1;
      r = xx1*xx1+yy1*yy1;
      
      while ((r<=max_r) && (k<iter))
      {
        xx2 = xx1*xx1-yy1*yy1+p;
        yy1 = 2*xx1*yy1+q;

        xx1=xx2;
        //yy1=yy2;

        k++;

        r = xx1*xx1+yy1*yy1;
        //poc_vyp++;
      }
      *pixels = k<<18 | k<<10| k<<2;
      //*pixels = k<<2;
      //double x = exp(-r)+16*sqrt(k/8.0);
      //*bufp = (Uint32) (x*4);
     
      pixels++;
      x1 = x1+dx;
    }
    y1=y1+dy;
    pixels = (unsigned int*)ddsd.lpSurface+(pitch>>2)*ny;
  }
  s->Unlock(NULL);
}
